;  strcmp.arm 

extern int strcmp(const char *p,const char *q);

;  strcpy.arm 

extern void strcpy(char *p,const char *q);

;  strlen.arm 

extern int strlen(const char *p);

;  strlower.arm 

extern void strlower(char *p);

;  allocmem.arm 

extern struct kernel_error *AllocMem(int bytes,void **pointer);

;  malloc.arm 

extern void *malloc(int bytes);

;  free.arm 

extern void free(void *);

;  memset.arm 

void memset(char *p,int c,int n);

;  ros1.arm 

extern struct kernel_error *riscos_filesize(const char *name,int *length);

;  ros2.arm 

extern int riscos_open(const char *name,int mode);
   /* returns 0 if not opened, or file handle otherwise */
   #define RO_RDONLY  0x40
   #define RO_WRONLY  0xc0
   #define RO_RDWR    0xc0
   #define RO_CREAT   0x80

;  ros3.arm 

extern int riscos_seek(int handle,int offset,int whence);
   #define SEEK_SET  0
   #define SEEK_CUR  1
   #define SEEK_END  2

;  ros4.arm 

extern int riscos_close(int handle);

;  ros5.arm 

extern int riscos_read(int handle,char *buffer,unsigned int length);
extern int riscos_write(int handle,char *buffer,unsigned int length);

;  ros6.arm 

extern int riscos_settype(const char *name,int type);
   #define RO_TYPE_OBEY       0xfeb
   #define RO_TYPE_TEMPLATE   0xfec
   #define RO_TYPE_SPRITE     0xff9
   #define RO_TYPE_MODULE     0xffa
   #define RO_TYPE_BASIC      0xffb
   #define RO_TYPE_TEXT       0xfff

;  ros7.arm 

extern int riscos_remove(const char *name);

;  relocate.arm 


;  EOF 
